Index: uspace/lib/ui/src/fixed.c
===================================================================
--- uspace/lib/ui/src/fixed.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/fixed.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * All rights reserved.
  *
@@ -46,5 +46,4 @@
 static void ui_fixed_ctl_destroy(void *);
 static errno_t ui_fixed_ctl_paint(void *);
-static ui_evclaim_t ui_fixed_ctl_kbd_event(void *, kbd_event_t *);
 static ui_evclaim_t ui_fixed_ctl_pos_event(void *, pos_event_t *);
 static void ui_fixed_ctl_unfocus(void *);
@@ -54,5 +53,4 @@
 	.destroy = ui_fixed_ctl_destroy,
 	.paint = ui_fixed_ctl_paint,
-	.kbd_event = ui_fixed_ctl_kbd_event,
 	.pos_event = ui_fixed_ctl_pos_event,
 	.unfocus = ui_fixed_ctl_unfocus
@@ -213,27 +211,4 @@
 }
 
-/** Handle fixed layout keyboard event.
- *
- * @param fixed Fixed layout
- * @param kbd_event Keyboard event
- * @return @c ui_claimed iff the event is claimed
- */
-ui_evclaim_t ui_fixed_kbd_event(ui_fixed_t *fixed, kbd_event_t *event)
-{
-	ui_fixed_elem_t *elem;
-	ui_evclaim_t claimed;
-
-	elem = ui_fixed_first(fixed);
-	while (elem != NULL) {
-		claimed = ui_control_kbd_event(elem->control, event);
-		if (claimed == ui_claimed)
-			return ui_claimed;
-
-		elem = ui_fixed_next(elem);
-	}
-
-	return ui_unclaimed;
-}
-
 /** Handle fixed layout position event.
  *
@@ -298,17 +273,4 @@
 }
 
-/** Handle fixed layout control keyboard event.
- *
- * @param arg Argument (ui_fixed_t *)
- * @param kbd_event Keyboard event
- * @return @c ui_claimed iff the event is claimed
- */
-ui_evclaim_t ui_fixed_ctl_kbd_event(void *arg, kbd_event_t *event)
-{
-	ui_fixed_t *fixed = (ui_fixed_t *) arg;
-
-	return ui_fixed_kbd_event(fixed, event);
-}
-
 /** Handle fixed layout control position event.
  *
Index: uspace/lib/ui/src/label.c
===================================================================
--- uspace/lib/ui/src/label.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/label.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -134,14 +134,4 @@
 {
 	label->halign = halign;
-}
-
-/** Set label vertical text alignment.
- *
- * @param label Label
- * @param valign Vertical alignment
- */
-void ui_label_set_valign(ui_label_t *label, gfx_valign_t valign)
-{
-	label->valign = valign;
 }
 
@@ -200,17 +190,5 @@
 	}
 
-	switch (label->valign) {
-	case gfx_valign_top:
-		pos.y = label->rect.p0.y;
-		break;
-	case gfx_valign_center:
-		pos.y = (label->rect.p0.y + label->rect.p1.y) / 2;
-		break;
-	case gfx_valign_bottom:
-		pos.y = label->rect.p1.y;
-		break;
-	case gfx_valign_baseline:
-		return EINVAL;
-	}
+	pos.y = label->rect.p0.y;
 
 	gfx_text_fmt_init(&fmt);
Index: uspace/lib/ui/src/menu.c
===================================================================
--- uspace/lib/ui/src/menu.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/menu.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -58,6 +58,5 @@
 	menu_frame_h = 4,
 	menu_frame_w_text = 2,
-	menu_frame_h_text = 1,
-	menu_frame_h_margin_text = 1
+	menu_frame_h_text = 1
 };
 
@@ -277,86 +276,4 @@
  * @return EOK on success or an error code
  */
-errno_t ui_menu_paint_bg_gfx(ui_menu_t *menu, gfx_coord2_t *spos)
-{
-	ui_resource_t *res;
-	ui_menu_geom_t geom;
-	gfx_rect_t bg_rect;
-	errno_t rc;
-
-	res = ui_menu_get_res(menu);
-	ui_menu_get_geom(menu, spos, &geom);
-
-	/* Paint menu frame */
-
-	rc = gfx_set_color(res->gc, res->wnd_face_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = ui_paint_outset_frame(res, &geom.outer_rect, &bg_rect);
-	if (rc != EOK)
-		goto error;
-
-	/* Paint menu background */
-
-	rc = gfx_set_color(res->gc, res->wnd_face_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_fill_rect(res->gc, &bg_rect);
-	if (rc != EOK)
-		goto error;
-
-	return EOK;
-error:
-	return rc;
-}
-
-/** Paint menu.
- *
- * @param menu Menu
- * @param spos Starting position (top-left corner)
- * @return EOK on success or an error code
- */
-errno_t ui_menu_paint_bg_text(ui_menu_t *menu, gfx_coord2_t *spos)
-{
-	ui_resource_t *res;
-	ui_menu_geom_t geom;
-	gfx_rect_t rect;
-	errno_t rc;
-
-	res = ui_menu_get_res(menu);
-	ui_menu_get_geom(menu, spos, &geom);
-
-	/* Paint menu background */
-
-	rc = gfx_set_color(res->gc, res->wnd_face_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_fill_rect(res->gc, &geom.outer_rect);
-	if (rc != EOK)
-		goto error;
-
-	/* Paint menu box */
-
-	rect = geom.outer_rect;
-	rect.p0.x += menu_frame_h_margin_text;
-	rect.p1.x -= menu_frame_h_margin_text;
-
-	rc = ui_paint_text_box(res, &rect, ui_box_single, res->wnd_face_color);
-	if (rc != EOK)
-		goto error;
-
-	return EOK;
-error:
-	return rc;
-}
-
-/** Paint menu.
- *
- * @param menu Menu
- * @param spos Starting position (top-left corner)
- * @return EOK on success or an error code
- */
 errno_t ui_menu_paint(ui_menu_t *menu, gfx_coord2_t *spos)
 {
@@ -365,4 +282,5 @@
 	ui_menu_entry_t *mentry;
 	ui_menu_geom_t geom;
+	gfx_rect_t bg_rect;
 	errno_t rc;
 
@@ -370,9 +288,21 @@
 	ui_menu_get_geom(menu, spos, &geom);
 
-	/* Paint menu frame and background */
-	if (res->textmode)
-		rc = ui_menu_paint_bg_text(menu, spos);
-	else
-		rc = ui_menu_paint_bg_gfx(menu, spos);
+	/* Paint menu frame */
+
+	rc = gfx_set_color(res->gc, res->wnd_face_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_paint_outset_frame(res, &geom.outer_rect, &bg_rect);
+	if (rc != EOK)
+		goto error;
+
+	/* Paint menu background */
+
+	rc = gfx_set_color(res->gc, res->wnd_face_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_fill_rect(res->gc, &bg_rect);
 	if (rc != EOK)
 		goto error;
Index: uspace/lib/ui/src/menuentry.c
===================================================================
--- uspace/lib/ui/src/menuentry.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/menuentry.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -349,22 +349,11 @@
 
 	if (mentry->separator) {
-		if (res->textmode) {
-			rect = geom.outer_rect;
-			rect.p0.x -= 1;
-			rect.p1.x += 1;
-
-			rc = ui_paint_text_hbrace(res, &rect, ui_box_single,
-			    res->wnd_face_color);
-			if (rc != EOK)
-				goto error;
-		} else {
-			rect.p0 = geom.caption_pos;
-			rect.p1.x = geom.shortcut_pos.x;
-			rect.p1.y = rect.p0.y + 2;
-			rc = ui_paint_bevel(res->gc, &rect, res->wnd_shadow_color,
-			    res->wnd_highlight_color, 1, NULL);
-			if (rc != EOK)
-				goto error;
-		}
+		rect.p0 = geom.caption_pos;
+		rect.p1.x = geom.shortcut_pos.x;
+		rect.p1.y = rect.p0.y + 2;
+		rc = ui_paint_bevel(res->gc, &rect, res->wnd_shadow_color,
+		    res->wnd_highlight_color, 1, NULL);
+		if (rc != EOK)
+			goto error;
 	}
 
Index: uspace/lib/ui/src/msgdialog.c
===================================================================
--- uspace/lib/ui/src/msgdialog.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/msgdialog.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -103,5 +103,5 @@
 		wparams.rect.p0.x = 0;
 		wparams.rect.p0.y = 0;
-		wparams.rect.p1.x = 40;
+		wparams.rect.p1.x = 20;
 		wparams.rect.p1.y = 7;
 	} else {
@@ -177,5 +177,4 @@
 		goto error;
 
-	dialog->bok = bok;
 	bok = NULL;
 
@@ -188,9 +187,8 @@
 
 	dialog->window = window;
+	dialog->bok = bok;
 	*rdialog = dialog;
 	return EOK;
 error:
-	if (bok != NULL)
-		ui_pbutton_destroy(bok);
 	if (label != NULL)
 		ui_label_destroy(label);
Index: uspace/lib/ui/src/paint.c
===================================================================
--- uspace/lib/ui/src/paint.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/paint.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -38,41 +38,6 @@
 #include <gfx/context.h>
 #include <gfx/render.h>
-#include <gfx/text.h>
 #include <ui/paint.h>
-#include <stdlib.h>
-#include <str.h>
 #include "../private/resource.h"
-
-/** Single box characters */
-static ui_box_chars_t single_box_chars = {
-	{
-		{ "\u250c", "\u2500", "\u2510" },
-		{ "\u2502", " ",      "\u2502" },
-		{ "\u2514", "\u2500", "\u2518" }
-	}
-};
-
-/** Double box characters */
-static ui_box_chars_t double_box_chars = {
-	{
-		{ "\u2554", "\u2550", "\u2557" },
-		{ "\u2551", " ",      "\u2551" },
-		{ "\u255a", "\u2550", "\u255d" }
-	}
-};
-
-/** Single horizontal brace characters */
-static ui_brace_chars_t single_hbrace_chars = {
-	.start = "\u251c",
-	.middle = "\u2500",
-	.end = "\u2524"
-};
-
-/** Double horizontal brace characters */
-static ui_brace_chars_t double_hbrace_chars = {
-	.start = "\u2560",
-	.middle = "\u2550",
-	.end = "\u2563"
-};
 
 /** Paint bevel.
@@ -84,5 +49,5 @@
  * @param thickness Bevel thickness in pixels
  * @param inside Place to store rectangle of the interior or @c NULL
- * @return EOK on success or an error code
+ * @reutrn EOK on success or an error code
  */
 errno_t ui_paint_bevel(gfx_context_t *gc, gfx_rect_t *rect,
@@ -142,28 +107,14 @@
 	}
 
-	if (inside != NULL)
-		ui_paint_get_bevel_inside(gc, rect, thickness, inside);
+	if (inside != NULL) {
+		inside->p0.x = rect->p0.x + thickness;
+		inside->p0.y = rect->p0.y + thickness;
+		inside->p1.x = rect->p1.x - thickness;
+		inside->p1.y = rect->p1.y - thickness;
+	}
 
 	return EOK;
 error:
 	return rc;
-}
-
-/** Get bevel interior rectangle.
- *
- * Get the bevel interior rectangle without painting it.
- *
- * @param gc Graphic context
- * @param rect Rectangle to paint into
- * @param thickness Bevel thickness in pixels
- * @param inside Place to store rectangle of the interior
- */
-void ui_paint_get_bevel_inside(gfx_context_t *gc, gfx_rect_t *rect,
-    gfx_coord_t thickness, gfx_rect_t *inside)
-{
-	inside->p0.x = rect->p0.x + thickness;
-	inside->p0.y = rect->p0.y + thickness;
-	inside->p1.x = rect->p1.x - thickness;
-	inside->p1.y = rect->p1.y - thickness;
 }
 
@@ -196,19 +147,4 @@
 error:
 	return rc;
-}
-
-/** Get inset frame interior rectangle.
- *
- * This allows one to get the interior rectangle without actually painting
- * the inset frame.
- *
- * @param resource UI resource
- * @param rect Rectangle to paint onto
- * @param inside Place to store inside rectangle or @c NULL
- */
-void ui_paint_get_inset_frame_inside(ui_resource_t *resource, gfx_rect_t *rect,
-    gfx_rect_t *inside)
-{
-	ui_paint_get_bevel_inside(resource->gc, rect, 2, inside);
 }
 
@@ -359,199 +295,4 @@
 }
 
-/** Paint a text box.
- *
- * @param resource UI resource
- * @param rect Rectangle inside which to paint the box
- * @param style Box style
- * @param color Color
- * @return EOK on success or an error code
- */
-errno_t ui_paint_text_box(ui_resource_t *resource, gfx_rect_t *rect,
-    ui_box_style_t style, gfx_color_t *color)
-{
-	errno_t rc;
-	gfx_text_fmt_t fmt;
-	gfx_rect_t srect;
-	gfx_coord2_t pos;
-	gfx_coord2_t dim;
-	size_t bufsz;
-	size_t off;
-	int i;
-	gfx_coord_t y;
-	char *str = NULL;
-	ui_box_chars_t *boxc = NULL;
-
-	gfx_rect_points_sort(rect, &srect);
-	gfx_rect_dims(&srect, &dim);
-
-	/* Is rectangle large enough to hold box? */
-	if (dim.x < 2 || dim.y < 2)
-		return EOK;
-
-	switch (style) {
-	case ui_box_single:
-		boxc = &single_box_chars;
-		break;
-	case ui_box_double:
-		boxc = &double_box_chars;
-		break;
-	}
-
-	if (boxc == NULL)
-		return EINVAL;
-
-	gfx_text_fmt_init(&fmt);
-	fmt.color = color;
-
-	bufsz = str_size(boxc->c[0][0]) +
-	    str_size(boxc->c[0][1]) * (dim.x - 2) +
-	    str_size(boxc->c[0][2]) + 1;
-
-	str = malloc(bufsz);
-	if (str == NULL)
-		return ENOMEM;
-
-	/* Top edge and corners */
-
-	str_cpy(str, bufsz, boxc->c[0][0]);
-	off = str_size(boxc->c[0][0]);
-
-	for (i = 1; i < dim.x - 1; i++) {
-		str_cpy(str + off, bufsz - off, boxc->c[0][1]);
-		off += str_size(boxc->c[0][1]);
-	}
-
-	str_cpy(str + off, bufsz - off, boxc->c[0][2]);
-	off += str_size(boxc->c[0][2]);
-	str[off] = '\0';
-
-	pos = rect->p0;
-	rc = gfx_puttext(resource->font, &pos, &fmt, str);
-	if (rc != EOK)
-		goto error;
-
-	/* Vertical edges */
-	for (y = rect->p0.y + 1; y < rect->p1.y - 1; y++) {
-		pos.y = y;
-
-		pos.x = rect->p0.x;
-		rc = gfx_puttext(resource->font, &pos, &fmt,
-		    boxc->c[1][0]);
-		if (rc != EOK)
-			goto error;
-
-		pos.x = rect->p1.x - 1;
-		rc = gfx_puttext(resource->font, &pos, &fmt,
-		    boxc->c[1][2]);
-		if (rc != EOK)
-			goto error;
-	}
-
-	/* Bottom edge and corners */
-
-	str_cpy(str, bufsz, boxc->c[2][0]);
-	off = str_size(boxc->c[2][0]);
-
-	for (i = 1; i < dim.x - 1; i++) {
-		str_cpy(str + off, bufsz - off, boxc->c[2][1]);
-		off += str_size(boxc->c[2][1]);
-	}
-
-	str_cpy(str + off, bufsz - off, boxc->c[2][2]);
-	off += str_size(boxc->c[2][2]);
-	str[off] = '\0';
-
-	pos.x = rect->p0.x;
-	pos.y = rect->p1.y - 1;
-	rc = gfx_puttext(resource->font, &pos, &fmt, str);
-	if (rc != EOK)
-		goto error;
-
-	free(str);
-	return EOK;
-error:
-	if (str != NULL)
-		free(str);
-	return rc;
-}
-
-/** Paint a text horizontal brace.
- *
- * @param resource UI resource
- * @param rect Rectangle inside which to paint the brace (height should
- *             be 1).
- * @param style Box style
- * @param color Color
- * @return EOK on success or an error code
- */
-errno_t ui_paint_text_hbrace(ui_resource_t *resource, gfx_rect_t *rect,
-    ui_box_style_t style, gfx_color_t *color)
-{
-	errno_t rc;
-	gfx_text_fmt_t fmt;
-	gfx_rect_t srect;
-	gfx_coord2_t pos;
-	gfx_coord2_t dim;
-	size_t bufsz;
-	size_t off;
-	int i;
-	char *str = NULL;
-	ui_brace_chars_t *hbc = NULL;
-
-	gfx_rect_points_sort(rect, &srect);
-	gfx_rect_dims(&srect, &dim);
-
-	/* Is rectangle large enough to hold brace? */
-	if (dim.x < 2 || dim.y < 1)
-		return EOK;
-
-	switch (style) {
-	case ui_box_single:
-		hbc = &single_hbrace_chars;
-		break;
-	case ui_box_double:
-		hbc = &double_hbrace_chars;
-		break;
-	}
-
-	if (hbc == NULL)
-		return EINVAL;
-
-	gfx_text_fmt_init(&fmt);
-	fmt.color = color;
-
-	bufsz = str_size(hbc->start) +
-	    str_size(hbc->middle) * (dim.x - 2) +
-	    str_size(hbc->end) + 1;
-
-	str = malloc(bufsz);
-	if (str == NULL)
-		return ENOMEM;
-
-	str_cpy(str, bufsz, hbc->start);
-	off = str_size(hbc->start);
-
-	for (i = 1; i < dim.x - 1; i++) {
-		str_cpy(str + off, bufsz - off, hbc->middle);
-		off += str_size(hbc->middle);
-	}
-
-	str_cpy(str + off, bufsz - off, hbc->end);
-	off += str_size(hbc->end);
-	str[off] = '\0';
-
-	pos = rect->p0;
-	rc = gfx_puttext(resource->font, &pos, &fmt, str);
-	if (rc != EOK)
-		goto error;
-
-	free(str);
-	return EOK;
-error:
-	if (str != NULL)
-		free(str);
-	return rc;
-}
-
 /** @}
  */
Index: uspace/lib/ui/src/pbutton.c
===================================================================
--- uspace/lib/ui/src/pbutton.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/pbutton.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -366,5 +366,5 @@
 	rect.p1.y = pbutton->rect.p0.y + 1;
 
-	rc = gfx_set_color(pbutton->res->gc, pbutton->res->btn_face_color);
+	rc = gfx_set_color(pbutton->res->gc, pbutton->res->btn_highlight_color);
 	if (rc != EOK)
 		goto error;
Index: uspace/lib/ui/src/rbutton.c
===================================================================
--- uspace/lib/ui/src/rbutton.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/rbutton.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -186,10 +186,10 @@
 }
 
-/** Paint radio button in graphics mode.
+/** Paint radio button.
  *
  * @param rbutton Radio button
  * @return EOK on success or an error code
  */
-errno_t ui_rbutton_paint_gfx(ui_rbutton_t *rbutton)
+errno_t ui_rbutton_paint(ui_rbutton_t *rbutton)
 {
 	gfx_coord2_t pos;
@@ -202,5 +202,5 @@
 	center.y = rbutton->rect.p0.y + rbutton_oframe_r;
 
-	/* Paint radio button frame */
+	/* Paint rbutton frame */
 
 	rc = gfx_set_color(rbutton->group->res->gc,
@@ -244,5 +244,5 @@
 		goto error;
 
-	/* Paint radio button interior */
+	/* Paint rbutton interior */
 	depressed = rbutton->held && rbutton->inside;
 
@@ -296,67 +296,4 @@
 }
 
-/** Paint radio button in text mode.
- *
- * @param rbutton Radio button
- * @return EOK on success or an error code
- */
-errno_t ui_rbutton_paint_text(ui_rbutton_t *rbutton)
-{
-	gfx_coord2_t pos;
-	gfx_text_fmt_t fmt;
-	bool depressed;
-	errno_t rc;
-
-	/* Paint radio button */
-
-	depressed = rbutton->held && rbutton->inside;
-
-	pos.x = rbutton->rect.p0.x;
-	pos.y = rbutton->rect.p0.y;
-
-	gfx_text_fmt_init(&fmt);
-	fmt.color = depressed ? rbutton->group->res->entry_act_bg_color :
-	    rbutton->group->res->wnd_text_color;
-	fmt.halign = gfx_halign_left;
-	fmt.valign = gfx_valign_top;
-
-	rc = gfx_puttext(rbutton->group->res->font, &pos, &fmt,
-	    rbutton->group->selected == rbutton ? "(\u2022)" : "( )");
-	if (rc != EOK)
-		goto error;
-
-	/* Paint radio button label */
-
-	pos.x += 4;
-
-	fmt.color = rbutton->group->res->wnd_text_color;
-
-	rc = gfx_puttext(rbutton->group->res->font, &pos, &fmt,
-	    rbutton->caption);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_update(rbutton->group->res->gc);
-	if (rc != EOK)
-		goto error;
-
-	return EOK;
-error:
-	return rc;
-}
-
-/** Paint radio button.
- *
- * @param rbutton Radio button
- * @return EOK on success or an error code
- */
-errno_t ui_rbutton_paint(ui_rbutton_t *rbutton)
-{
-	if (rbutton->group->res->textmode)
-		return ui_rbutton_paint_text(rbutton);
-	else
-		return ui_rbutton_paint_gfx(rbutton);
-}
-
 /** Press down button.
  *
@@ -379,4 +316,6 @@
 void ui_rbutton_release(ui_rbutton_t *rbutton)
 {
+	ui_rbutton_t *old_selected;
+
 	if (!rbutton->held)
 		return;
@@ -386,5 +325,16 @@
 	if (rbutton->inside) {
 		/* Activate radio button */
-		ui_rbutton_select(rbutton);
+		old_selected = rbutton->group->selected;
+
+		if (old_selected != rbutton) {
+			rbutton->group->selected = rbutton;
+			ui_rbutton_paint(old_selected);
+		}
+
+		/* Repaint and notify */
+		(void) ui_rbutton_paint(rbutton);
+
+		if (old_selected != rbutton)
+			ui_rbutton_selected(rbutton);
 	}
 }
@@ -418,27 +368,5 @@
 }
 
-/** Select radio button.
- *
- * @param rbutton Radio button
- */
-void ui_rbutton_select(ui_rbutton_t *rbutton)
-{
-	ui_rbutton_t *old_selected;
-
-	old_selected = rbutton->group->selected;
-
-	if (old_selected != rbutton) {
-		rbutton->group->selected = rbutton;
-		ui_rbutton_paint(old_selected);
-	}
-
-	/* Repaint and notify */
-	(void) ui_rbutton_paint(rbutton);
-
-	if (old_selected != rbutton)
-		ui_rbutton_selected(rbutton);
-}
-
-/** Notify that button was selected.
+/** Button was selected.
  *
  * @param rbutton Radio button
Index: uspace/lib/ui/src/resource.c
===================================================================
--- uspace/lib/ui/src/resource.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/resource.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -47,11 +47,12 @@
 static const char *ui_typeface_path = "/data/font/helena.tpf";
 
-/** Create new UI resource in graphics mode.
+/** Create new UI resource.
  *
  * @param gc Graphic context
+ * @param textmode @c true if running in text mode
  * @param rresource Place to store pointer to new UI resource
  * @return EOK on success, ENOMEM if out of memory
  */
-static errno_t ui_resource_create_gfx(gfx_context_t *gc,
+errno_t ui_resource_create(gfx_context_t *gc, bool textmode,
     ui_resource_t **rresource)
 {
@@ -80,6 +81,4 @@
 	gfx_color_t *entry_bg_color = NULL;
 	gfx_color_t *entry_act_bg_color = NULL;
-	gfx_color_t *entry_sel_text_fg_color = NULL;
-	gfx_color_t *entry_sel_text_bg_color = NULL;
 	errno_t rc;
 
@@ -88,17 +87,28 @@
 		return ENOMEM;
 
-	rc = gfx_typeface_open(gc, ui_typeface_path, &tface);
-	if (rc != EOK)
-		goto error;
-
-	finfo = gfx_typeface_first_font(tface);
-	if (finfo == NULL) {
-		rc = EIO;
-		goto error;
+	if (textmode) {
+		/* Create dummy font for text mode */
+		rc = gfx_typeface_create(gc, &tface);
+		if (rc != EOK)
+			goto error;
+
+		rc = gfx_font_create_textmode(tface, &font);
+		if (rc != EOK)
+			goto error;
+	} else {
+		rc = gfx_typeface_open(gc, ui_typeface_path, &tface);
+		if (rc != EOK)
+			goto error;
+
+		finfo = gfx_typeface_first_font(tface);
+		if (finfo == NULL) {
+			rc = EIO;
+			goto error;
+		}
+
+		rc = gfx_font_open(finfo, &font);
+		if (rc != EOK)
+			goto error;
 	}
-
-	rc = gfx_font_open(finfo, &font);
-	if (rc != EOK)
-		goto error;
 
 	rc = gfx_color_new_rgb_i16(0, 0, 0, &btn_frame_color);
@@ -185,13 +195,4 @@
 
 	rc = gfx_color_new_rgb_i16(0xc8c8, 0xc8c8, 0xc8c8, &entry_act_bg_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff,
-	    &entry_sel_text_fg_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_rgb_i16(0, 0, 0xffff, &entry_sel_text_bg_color);
 	if (rc != EOK)
 		goto error;
@@ -200,5 +201,5 @@
 	resource->tface = tface;
 	resource->font = font;
-	resource->textmode = false;
+	resource->textmode = textmode;
 
 	resource->btn_frame_color = btn_frame_color;
@@ -225,6 +226,4 @@
 	resource->entry_bg_color = entry_bg_color;
 	resource->entry_act_bg_color = entry_act_bg_color;
-	resource->entry_sel_text_fg_color = entry_sel_text_fg_color;
-	resource->entry_sel_text_bg_color = entry_sel_text_bg_color;
 
 	*rresource = resource;
@@ -272,8 +271,4 @@
 	if (entry_bg_color != NULL)
 		gfx_color_delete(entry_bg_color);
-	if (entry_sel_text_fg_color != NULL)
-		gfx_color_delete(entry_sel_text_fg_color);
-	if (entry_sel_text_bg_color != NULL)
-		gfx_color_delete(entry_sel_text_bg_color);
 	if (entry_act_bg_color != NULL)
 		gfx_color_delete(entry_act_bg_color);
@@ -283,245 +278,4 @@
 	free(resource);
 	return rc;
-}
-
-/** Create new UI resource in text mode.
- *
- * @param gc Graphic context
- * @param rresource Place to store pointer to new UI resource
- * @return EOK on success, ENOMEM if out of memory
- */
-static errno_t ui_resource_create_text(gfx_context_t *gc,
-    ui_resource_t **rresource)
-{
-	ui_resource_t *resource;
-	gfx_typeface_t *tface = NULL;
-	gfx_font_t *font = NULL;
-	gfx_color_t *btn_frame_color = NULL;
-	gfx_color_t *btn_face_color = NULL;
-	gfx_color_t *btn_text_color = NULL;
-	gfx_color_t *btn_highlight_color = NULL;
-	gfx_color_t *btn_shadow_color = NULL;
-	gfx_color_t *wnd_face_color = NULL;
-	gfx_color_t *wnd_text_color = NULL;
-	gfx_color_t *wnd_sel_text_color = NULL;
-	gfx_color_t *wnd_sel_text_bg_color = NULL;
-	gfx_color_t *wnd_frame_hi_color = NULL;
-	gfx_color_t *wnd_frame_sh_color = NULL;
-	gfx_color_t *wnd_highlight_color = NULL;
-	gfx_color_t *wnd_shadow_color = NULL;
-	gfx_color_t *tbar_act_bg_color = NULL;
-	gfx_color_t *tbar_inact_bg_color = NULL;
-	gfx_color_t *tbar_act_text_color = NULL;
-	gfx_color_t *tbar_inact_text_color = NULL;
-	gfx_color_t *entry_fg_color = NULL;
-	gfx_color_t *entry_bg_color = NULL;
-	gfx_color_t *entry_sel_text_fg_color = NULL;
-	gfx_color_t *entry_sel_text_bg_color = NULL;
-	gfx_color_t *entry_act_bg_color = NULL;
-	errno_t rc;
-
-	resource = calloc(1, sizeof(ui_resource_t));
-	if (resource == NULL)
-		return ENOMEM;
-
-	/* Create dummy font for text mode */
-	rc = gfx_typeface_create(gc, &tface);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_font_create_textmode(tface, &font);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x07, &btn_frame_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x20, &btn_face_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x20, &btn_text_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x20, &btn_highlight_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x01, &btn_shadow_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x70, &wnd_face_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x70, &wnd_text_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x07, &wnd_sel_text_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x07, &wnd_sel_text_bg_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x70, &wnd_frame_hi_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x01, &wnd_frame_sh_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x70, &wnd_highlight_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x01, &wnd_shadow_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x70, &tbar_act_bg_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x70, &tbar_act_text_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x07, &tbar_inact_bg_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x07, &tbar_inact_text_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x1b, &entry_fg_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x1b, &entry_bg_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x20, &entry_sel_text_fg_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x20, &entry_sel_text_bg_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x37, &entry_act_bg_color);
-	if (rc != EOK)
-		goto error;
-
-	resource->gc = gc;
-	resource->tface = tface;
-	resource->font = font;
-	resource->textmode = true;
-
-	resource->btn_frame_color = btn_frame_color;
-	resource->btn_face_color = btn_face_color;
-	resource->btn_text_color = btn_text_color;
-	resource->btn_highlight_color = btn_highlight_color;
-	resource->btn_shadow_color = btn_shadow_color;
-
-	resource->wnd_face_color = wnd_face_color;
-	resource->wnd_text_color = wnd_text_color;
-	resource->wnd_sel_text_color = wnd_sel_text_color;
-	resource->wnd_sel_text_bg_color = wnd_sel_text_bg_color;
-	resource->wnd_frame_hi_color = wnd_frame_hi_color;
-	resource->wnd_frame_sh_color = wnd_frame_sh_color;
-	resource->wnd_highlight_color = wnd_highlight_color;
-	resource->wnd_shadow_color = wnd_shadow_color;
-
-	resource->tbar_act_bg_color = tbar_act_bg_color;
-	resource->tbar_act_text_color = tbar_act_text_color;
-	resource->tbar_inact_bg_color = tbar_inact_bg_color;
-	resource->tbar_inact_text_color = tbar_inact_text_color;
-
-	resource->entry_fg_color = entry_fg_color;
-	resource->entry_bg_color = entry_bg_color;
-	resource->entry_act_bg_color = entry_act_bg_color;
-	resource->entry_sel_text_fg_color = entry_sel_text_fg_color;
-	resource->entry_sel_text_bg_color = entry_sel_text_bg_color;
-
-	*rresource = resource;
-	return EOK;
-error:
-	if (btn_frame_color != NULL)
-		gfx_color_delete(btn_frame_color);
-	if (btn_face_color != NULL)
-		gfx_color_delete(btn_face_color);
-	if (btn_text_color != NULL)
-		gfx_color_delete(btn_text_color);
-	if (btn_highlight_color != NULL)
-		gfx_color_delete(btn_highlight_color);
-	if (btn_shadow_color != NULL)
-		gfx_color_delete(btn_shadow_color);
-
-	if (wnd_face_color != NULL)
-		gfx_color_delete(wnd_face_color);
-	if (wnd_text_color != NULL)
-		gfx_color_delete(wnd_text_color);
-	if (wnd_sel_text_color != NULL)
-		gfx_color_delete(wnd_sel_text_color);
-	if (wnd_sel_text_bg_color != NULL)
-		gfx_color_delete(wnd_sel_text_bg_color);
-	if (wnd_frame_hi_color != NULL)
-		gfx_color_delete(wnd_frame_hi_color);
-	if (wnd_frame_sh_color != NULL)
-		gfx_color_delete(wnd_frame_sh_color);
-	if (wnd_highlight_color != NULL)
-		gfx_color_delete(wnd_highlight_color);
-	if (wnd_shadow_color != NULL)
-		gfx_color_delete(wnd_shadow_color);
-
-	if (tbar_act_bg_color != NULL)
-		gfx_color_delete(tbar_act_bg_color);
-	if (tbar_act_text_color != NULL)
-		gfx_color_delete(tbar_act_text_color);
-	if (tbar_inact_bg_color != NULL)
-		gfx_color_delete(tbar_inact_bg_color);
-	if (tbar_inact_text_color != NULL)
-		gfx_color_delete(tbar_inact_text_color);
-
-	if (entry_fg_color != NULL)
-		gfx_color_delete(entry_fg_color);
-	if (entry_bg_color != NULL)
-		gfx_color_delete(entry_bg_color);
-	if (entry_act_bg_color != NULL)
-		gfx_color_delete(entry_act_bg_color);
-	if (entry_sel_text_fg_color != NULL)
-		gfx_color_delete(entry_sel_text_fg_color);
-	if (entry_sel_text_bg_color != NULL)
-		gfx_color_delete(entry_sel_text_bg_color);
-
-	if (tface != NULL)
-		gfx_typeface_destroy(tface);
-	free(resource);
-	return rc;
-}
-
-/** Create new UI resource.
- *
- * @param gc Graphic context
- * @param textmode @c true if running in text mode
- * @param rresource Place to store pointer to new UI resource
- * @return EOK on success, ENOMEM if out of memory
- */
-errno_t ui_resource_create(gfx_context_t *gc, bool textmode,
-    ui_resource_t **rresource)
-{
-	if (textmode)
-		return ui_resource_create_text(gc, rresource);
-	else
-		return ui_resource_create_gfx(gc, rresource);
 }
 
@@ -558,6 +312,4 @@
 	gfx_color_delete(resource->entry_bg_color);
 	gfx_color_delete(resource->entry_act_bg_color);
-	gfx_color_delete(resource->entry_sel_text_fg_color);
-	gfx_color_delete(resource->entry_sel_text_bg_color);
 
 	gfx_font_close(resource->font);
@@ -594,14 +346,4 @@
 }
 
-/** Get the UI font.
- *
- * @param resource UI resource
- * @return UI font
- */
-gfx_font_t *ui_resource_get_font(ui_resource_t *resource)
-{
-	return resource->font;
-}
-
 /** @}
  */
Index: uspace/lib/ui/src/slider.c
===================================================================
--- uspace/lib/ui/src/slider.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/slider.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -38,5 +38,4 @@
 #include <gfx/context.h>
 #include <gfx/render.h>
-#include <gfx/text.h>
 #include <io/pos_event.h>
 #include <stdlib.h>
@@ -58,6 +57,4 @@
 	/** Slider button height */
 	ui_slider_btn_h = 23,
-	/** Slider button width in text mode */
-	ui_slider_btn_w_text = 3,
 	/** Slider button frame thickness */
 	ui_slider_btn_frame_thickness = 1,
@@ -254,18 +251,15 @@
 {
 	gfx_coord2_t dims;
-	gfx_coord_t w;
 
 	gfx_rect_dims(&slider->rect, &dims);
-	w = slider->res->textmode ? ui_slider_btn_w_text :
-	    ui_slider_btn_w;
-	return dims.x - w;
-}
-
-/** Paint slider in graphics mode.
+	return dims.x - ui_slider_btn_w;
+}
+
+/** Paint slider.
  *
  * @param slider Slider
  * @return EOK on success or an error code
  */
-errno_t ui_slider_paint_gfx(ui_slider_t *slider)
+errno_t ui_slider_paint(ui_slider_t *slider)
 {
 	gfx_coord2_t pos;
@@ -321,76 +315,4 @@
 }
 
-/** Paint slider in text mode.
- *
- * @param slider Slider
- * @return EOK on success or an error code
- */
-errno_t ui_slider_paint_text(ui_slider_t *slider)
-{
-	gfx_coord2_t pos;
-	gfx_text_fmt_t fmt;
-	gfx_coord_t w, i;
-	char *buf;
-	const char *gchar;
-	size_t gcharsz;
-	errno_t rc;
-
-	/* Paint slider groove */
-
-	pos = slider->rect.p0;
-
-	gfx_text_fmt_init(&fmt);
-	fmt.color = slider->res->wnd_text_color;
-	fmt.halign = gfx_halign_left;
-	fmt.valign = gfx_valign_top;
-
-	w = slider->rect.p1.x - slider->rect.p0.x;
-	gchar = "\u2550";
-	gcharsz = str_size(gchar);
-
-	buf = malloc(w * gcharsz + 1);
-	if (buf == NULL)
-		return ENOMEM;
-
-	for (i = 0; i < w; i++)
-		str_cpy(buf + i * gcharsz, (w - i) * gcharsz + 1, gchar);
-	buf[w * gcharsz] = '\0';
-
-	rc = gfx_puttext(slider->res->font, &pos, &fmt, buf);
-	free(buf);
-	if (rc != EOK)
-		goto error;
-
-	/* Paint slider button */
-
-	pos.x += slider->pos;
-
-	rc = gfx_puttext(slider->res->font, &pos, &fmt,
-	    "[O]");
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_update(slider->res->gc);
-	if (rc != EOK)
-		goto error;
-
-	return EOK;
-error:
-	return rc;
-}
-
-/** Paint slider.
- *
- * @param slider Slider
- * @return EOK on success or an error code
- */
-errno_t ui_slider_paint(ui_slider_t *slider)
-{
-	if (slider->res->textmode)
-		return ui_slider_paint_text(slider);
-	else
-		return ui_slider_paint_gfx(slider);
-}
-
 /** Clear slider button.
  *
@@ -402,8 +324,4 @@
 	gfx_rect_t rect;
 	errno_t rc;
-
-	/* No need to clear button in text mode */
-	if (slider->res->textmode)
-		return EOK;
 
 	ui_slider_btn_rect(slider, &rect);
